【算法】动态规划:回文子串问题、两个数组的dp

⭐️个人主页:@小羊 ⭐️所属专栏:算法 很荣幸您能阅读我的文章,诚请评论指点,欢迎欢迎 ~

目录


回文子串问题

回文子串

定义 dp[i][j] 表示以i位置元素为头,j位置元素为尾的回文子串,i <= j,要特别注意填表顺序。

cpp 复制代码
class Solution {
public:
    int countSubstrings(string s) {
        int n = s.size();
        vector<vector<bool>> dp(n, vector<bool>(n));
        int ret = 0;
        for (int i = n - 1; i >= 0; i--)
        {
            for (int j = i; j < n; j++)
            {
                if (s[i] == s[j])
                    dp[i][j] = i + 1 < j ? dp[i + 1][j - 1] : true;
                if (dp[i][j]) ret++;
            }
        }
        return ret;
    }
}; 

最长回文子串

一边填dp表,一边统计最长的回文子串。

cpp 复制代码
class Solution {
public:
    string longestPalindrome(string s) {
        int n = s.size();
        vector<vector<bool>> dp(n, vector<bool>(n));
        int begin = 0, len = 1;
        for (int i = n - 1; i >= 0; i--)
            for (int j = i; j < n; j++)
            {
                if (s[i] == s[j]) dp[i][j] = i + 1 < j ? dp[i + 1][j - 1] : true;
                if (dp[i][j] && j - i + 1 > len) 
                {
                    len = j - i + 1;
                    begin = i;
                }
            }
        return s.substr(begin, len);
    }
}; 

分割回文串 IV

cpp 复制代码
class Solution {
public:
    bool checkPartitioning(string s) {
        int n = s.size();
        vector<vector<bool>> dp(n, vector<bool>(n));
        for (int i = n - 1; i >= 0; i--)
            for (int j = i; j < n; j++)
                if (s[i] == s[j]) dp[i][j] = i + 1 < j ? dp[i + 1][j - 1] : true;
        for (int i = 0; i < n - 1; i++)
            for (int j = 0; j < n - 1; j++)
                if (dp[0][i] && dp[i + 1][j] && dp[j + 1][n - 1])
                    return true;
        return false;
    }
};

分割回文串 II *

定义状态 dp[i] 表示0-i区间符合要求的最少分割次数。

如果 j - i 是回文子串,则 dpi = dpj - 1 + 1;后面的+1表示分割一次。

cpp 复制代码
class Solution {
public:
    int minCut(string s) {
        int n = s.size();
        vector<vector<bool>> isPal(n, vector<bool>(n));
        for (int i = n - 1; i >= 0; i--)
            for (int j = i; j < n; j++)
                if (s[i] == s[j]) isPal[i][j] = i + 1 < j ? isPal[i + 1][j - 1] : true;
        vector<int> dp(n, INT_MAX);
        for (int i = 0; i < n; i++)
        {
            if (isPal[0][i]) dp[i] = 0;
            else
            {
                for (int j = 1; j <= i; j++)
                    if (isPal[j][i])
                        dp[i] = min(dp[j - 1] + 1, dp[i]);
            }
        }
        return dp[n - 1];
    }
};

最长回文子序列

定义状态 dp[i][j] 表示区间 i到j 范围内的所有子序列中,最长回文子序列的长度。

当首尾两个元素「相同」的时候,也就是si == sj :那么i, j 区间上的最长回文子序列,应该是i + 1, j - 1 区间内的那个最长回文子序列首尾填上si 和sj ,此时dp[i][j] = dp[i + 1][j - 1] + 2.

当 s[i] != s[j] 时: dp[i][j] = max(dp[i][j - 1], dp[i + 1][j])。

cpp 复制代码
class Solution {
public:
    int longestPalindromeSubseq(string s) {
        int n = s.size();
        vector<vector<int>> dp(n, vector<int>(n));
        for (int i = n - 1; i >= 0; i--)
        {
            dp[i][i] = 1;
            for (int j = i + 1; j < n; j++)
            {
                if (s[i] == s[j]) dp[i][j] = dp[i + 1][j - 1] + 2;
                else dp[i][j] = max(dp[i][j - 1], dp[i + 1][j]);
            }
        }
        return dp[0][n - 1];
    }
};

让字符串成为回文串的最少插入次数

定义状态 dp[i][j] 表示让i到j区间称为回文串的最小插入次数。


i == j 时不用考虑,在初始化dp表的时候其中的值默认为0,所以直接在 j = i + 1 处开始遍历;i + 1 == j 可以放在 i + 1 < j 中,因为 dp[i + 1][j - 1] 访问的是 i + 1 == j 的左下角,这个位置刚好用不到,默认也为0。

当 s[i] != s[j] 时,我们假定在i的左边插入一个sj,或在j的右边插入一个si,然后就可以在 dp[i][j - 1] 或 dp[i + 1][j] 中找最小操作次数。

cpp 复制代码
class Solution {
public:
    int minInsertions(string s) {
        int n = s.size();
        vector<vector<int>> dp(n, vector<int>(n));
        for (int i = n - 1; i >= 0; i--)
        {
            for (int j = i + 1; j < n; j++)
                if (s[i] == s[j]) dp[i][j] = dp[i + 1][j - 1];
                else dp[i][j] = min(dp[i + 1][j], dp[i][j - 1]) + 1;
        }
        return dp[0][n - 1];
    }
};

两个数组的dp

最长公共子序列

定义状态 dp[i][j] 为s1的0, i区间和s2的0, j区间中所有的子序列中,最长公共子序列的长度。

cpp 复制代码
class Solution {
public:
    int longestCommonSubsequence(string text1, string text2) {
        int m = text1.size(), n = text2.size();
        vector<vector<int>> dp(m + 1, vector<int>(n + 1));
        for (int i = 1; i <= m; i++)
        {
            for (int j = 1; j <= n; j++)
            {
                if (text1[i-1] == text2[j-1]) dp[i][j] = dp[i-1][j-1] + 1;
                else dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
            }
        }
        return dp[m][n];
    }
};

不相交的线

说白了我白说了,这就是 "最长公共子序列"。

我是程序猿,我可以作证,代码一模一样。

cpp 复制代码
class Solution {
public:
    int maxUncrossedLines(vector<int>& nums1, vector<int>& nums2) {
        int m = nums1.size(), n = nums2.size();
        vector<vector<int>> dp(m + 1, vector<int>(n + 1));
        for (int i = 1; i <= m; i++)
        {
            for (int j = 1; j <= n; j++)
            {
                if (nums1[i-1] == nums2[j-1]) dp[i][j] = dp[i-1][j-1] + 1;
                else dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
            }
        }
        return dp[m][n];
    }
};

不同的子序列

dp[i][j] 表示s的0, j区间中所有的子序列 中有多少个t的0, j区间的子串。

cpp 复制代码
class Solution {
public:
    int numDistinct(string s, string t) {
        const int mod = 1e9 + 7;
        int m = t.size(), n = s.size();
        vector<vector<int>> dp(m + 1, vector<int>(n + 1));
        for (int i = 0; i < n; i++) dp[0][i] = 1;
        for (int i = 1; i <= m; i++)
        {
            for (int j = 1; j <= n; j++)
            {
                dp[i][j] = dp[i][j - 1];
                if (s[j - 1] == t[i - 1])
                    dp[i][j] = (dp[i][j] + dp[i - 1][j - 1]) % mod;
            }
        }
        return dp[m][n];
    }
};

通配符匹配 *

dp[i][j] 表示 p[0, j] 内的子串能否匹配 s[0, i] 内的子串。

cpp 复制代码
class Solution {
public:
    bool isMatch(string s, string p) {
        int m = s.size(), n = p.size();
        // 对应下标
        s = ' ' + s;
        p = ' ' + p;
        vector<vector<bool>> dp(m + 1, vector<bool>(n + 1));

        // 初始化空串的情况
        dp[0][0] = true;
        for (int i = 1; i <= n; i++)
            if (p[i] == '*') dp[0][i] = true;
            else break;

        for (int i = 1; i <= m; i++)
            for (int j = 1; j <= n; j++)
                if (p[j] == '*') dp[i][j] = dp[i - 1][j] || dp[i][j - 1];
                else dp[i][j] = (p[j] == '?' || s[i] == p[j]) && dp[i - 1][j - 1];

        return dp[m][n];
    }
};

正则表达式匹配

定义状态 dp[i][j] 表示 p[0, j] 区间内的子串能否匹配 s[0, i] 区间内的子串。

cpp 复制代码
class Solution {
public:
    bool isMatch(string s, string p) {
        int m = s.size(), n = p.size();
        // 对应下标
        s = ' ' + s;
        p = ' ' + p;
        vector<vector<bool>> dp(m + 1, vector<bool>(n + 1));

        // 初始化空串的情况
        dp[0][0] = true;
        for (int i = 2; i <= n; i += 2)
            if (p[i] == '*') dp[0][i] = true;
            else break;

        for (int i = 1; i <= m; i++)
        {
            for (int j = 1; j <= n; j++)
            {
                if (p[j] == '*') 
                    dp[i][j] = dp[i][j-2] || ((s[i] == p[j-1] || p[j-1] == '.') && dp[i-1][j]);
                else
                    dp[i][j] = (s[i] == p[j] || p[j] == '.') && dp[i-1][j-1];
            }
        }
        return dp[m][n];
    }
};

交错字符串

定义状态 dp[i, j] 表示 s1[0, i] 区间内的字符串和 s2[0, j] 区间内的字符串能否拼接成 s3[0, i + j] 区间内的字符串。

cpp 复制代码
class Solution {
public:
    bool isInterleave(string s1, string s2, string s3) {
        int m = s1.size(), n = s2.size();
        if (m + n != s3.size()) return false;
        s1 = ' ' + s1, s2 = ' ' + s2, s3 = ' ' + s3;

        vector<vector<bool>> dp(m + 1, vector<bool>(n + 1));
        dp[0][0] = true;
        for (int i = 1; i <= n; i++)
            if (s2[i] == s3[i]) dp[0][i] = true;
            else break;
        for (int i = 0; i <= m; i++)
            if (s1[i] == s3[i]) dp[i][0] = true;
            else break;
        
        for (int i = 1; i <= m; i++)
            for (int j = 1; j <= n; j++)
                dp[i][j] = (s1[i] == s3[i + j] && dp[i - 1][j]) 
                            || (s2[j] == s3[i + j] && dp[i][j - 1]);
        return dp[m][n];
    }
};

两个字符串的最小ASCII删除和

实际就是求两个字符串的最长公共子序列的ASCII码和。

定义状态 dp[i][j] 表示s10, i区间和s20, j区间内的所有子序列中,最长公共子序列的ASCII码和。

对于初始化dp表,当s1为空串或s2为空串时,dp[0][i] 和 dp[j][0] 都为0。

cpp 复制代码
class Solution {
public:
    int minimumDeleteSum(string s1, string s2) {
        int m = s1.size(), n = s2.size();
        vector<vector<int>> dp(m + 1, vector<int>(n + 1));
        for (int i = 1; i <= m; i++)
        {
            for (int j = 1; j <= n; j++)
            {
                dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
                if (s1[i - 1] == s2[j - 1])
                    dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + s1[i - 1]);
            }
        }
        int sum = 0;
        for (char ch : s1) sum += ch;
        for (char ch : s2) sum += ch;
        return sum - dp[m][n] - dp[m][n];
    }
};

最长重复子数组

cpp 复制代码
class Solution {
public:
    int findLength(vector<int>& nums1, vector<int>& nums2) {
        int m = nums1.size(), n = nums2.size();
        vector<vector<int>> dp(m + 1, vector<int>(n + 1));
        int ret = 0;
        for (int i = 1; i <= m; i++)
        {
            for (int j = 1; j <= n; j++)
            {
                if (nums1[i - 1] == nums2[j - 1])
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                ret = max(ret, dp[i][j]);
            }
        }
        return ret;
    }
};

本篇文章的分享就到这里了,如果您觉得在本文有所收获,还请留下您的三连支持哦~

相关推荐
yi0118 小时前
LeetCode 219:存在重复元素 II——哈希表记录“最近一次出现的位置”
数据结构·人工智能·笔记·python·算法·leetcode·哈希表
灯澜忆梦10 小时前
【面向对象编程C++】| 基础语法
java·c++·算法
小蒋观天下10 小时前
专项方案:大场景港口AI安防、多干扰环境下的算法调优与落地实操
人工智能·深度学习·算法·安全·机器学习·计算机视觉·ai大模型
Evand J11 小时前
【电机滤波例程5】渐消因子自适应扩展卡尔曼滤波(EKF),MATLAB。PMSM负载突变下的状态估计。附下载链接
算法·matlab
H.莓飛11 小时前
【数据结构】二叉树_OJ题
linux·开发语言·数据结构·算法
好想像大佬一样能够ak所有11 小时前
Leetcode35.搜索插入位置
数据结构·算法·leetcode
aqiu11111111 小时前
【C++算法打怪专栏】LeetCode 165. 比较版本号(双指针与字符串流法)
c++·算法·leetcode
黄金龙PLUS12 小时前
如何基于置换算法来设计对称加密算法
算法·网络安全·密码学·哈希算法·同态加密
不会就选b12 小时前
算法日常・每日刷题--<动态规划>14
算法
赛博守夜人12 小时前
跨境业务与出海合规之九:海外买量投放与营销虚假流量(Ad Fraud):跨国机房群控与归因欺诈识别算法
算法·安全